SystemOrganization addCategory: #'XML-Parser-GTExtensions'!
SystemOrganization addCategory: 'XML-Parser-GTExtensions-Highlighting'!
SystemOrganization addCategory: 'XML-Parser-GTExtensions-Highlighting-Parser'!
SystemOrganization addCategory: 'XML-Parser-GTExtensions-Highlighting-Writer'!

!ZnStringEntity methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 5/8/2015 23:03'!
gtInspectorXmlIn: composite
	<gtInspectorPresentationOrder: 40>
	| xml |
	xml := [XMLDOMParser parse: self string]
		on: XMLParserException
		do: [ ^ self ].
	(xml gtInspectorTreeIn: composite)
		title: 'XML'! !

!XMLDoctypeDeclaration methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 9/29/2015 19:33'!
writeTreeNodeLabelXMLOn: aWriter
	aWriter lineBreak: ''. "suppress blank line after doctype"
	aWriter doctype
		root: self root;
		publicID: self publicID;
		systemID: self systemID.! !

GLMHighlighterTextStylerDecorator subclass: #GLMXMLHighlighterTextStylerDecorator
	instanceVariableNames: 'highlightableLengthLimit errorColor encodingName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-GTExtensions-Highlighting-Parser'!

!GLMXMLHighlighterTextStylerDecorator commentStamp: 'monty 10/2/2015 04:52' prior: 0!
A highlighter text styler decorator for XML source code.!

!GLMXMLHighlighterTextStylerDecorator methodsFor: 'accessing' stamp: 'monty 10/4/2015 01:18'!
converter
	| converter |

	self encodingName
		ifEmpty: [^ nil].

	(converter := TextConverter newForEncoding: encodingName)
		ifNil: [self error: 'Cannot convert encoding: "', encodingName, '"'].

	((converter respondsTo: #useLittleEndian:)
		and: [encodingName asLowercase endsWith: '-le'])
		ifTrue: [converter useLittleEndian: true].

	^ converter.! !

!GLMXMLHighlighterTextStylerDecorator methodsFor: 'accessing' stamp: 'monty 10/1/2015 21:52'!
defaultStyler
	^ GLMHighlighterTextParserStyler new
		view: self;
		parser: self! !

!GLMXMLHighlighterTextStylerDecorator methodsFor: 'accessing' stamp: 'monty 10/4/2015 00:40'!
encodingName
	^ encodingName! !

!GLMXMLHighlighterTextStylerDecorator methodsFor: 'accessing' stamp: 'monty 10/3/2015 02:11'!
errorColor
	^ errorColor! !

!GLMXMLHighlighterTextStylerDecorator methodsFor: 'accessing' stamp: 'monty 10/3/2015 02:12'!
errorColor: aTextColor
	errorColor := aTextColor! !

!GLMXMLHighlighterTextStylerDecorator methodsFor: 'accessing' stamp: 'monty 10/3/2015 02:11'!
highlightableLengthLimit
	^ highlightableLengthLimit! !

!GLMXMLHighlighterTextStylerDecorator methodsFor: 'accessing' stamp: 'monty 10/3/2015 02:08'!
highlightableLengthLimit: aLimit
	highlightableLengthLimit := aLimit! !

!GLMXMLHighlighterTextStylerDecorator methodsFor: 'initialization' stamp: 'monty 10/4/2015 00:37'!
initialize
	super initialize.

	highlightableLengthLimit := 100000.
	errorColor := TextColor red.
	encodingName := ''.! !

!GLMXMLHighlighterTextStylerDecorator methodsFor: 'parsing' stamp: 'monty 10/3/2015 05:09'!
parse: aString onError: anError
	| highlightingParser parser highlightedText |

	aString size > self highlightableLengthLimit
		ifTrue: [^ aString asText].

	highlightingParser := XMLHighlightingParser on: aString.
	parser := highlightingParser parser. "used to get position on error"
	[parser parseDocument.
		highlightedText := highlightingParser asHighlightedText]
		on: XMLParserException
		do: [:error |
			highlightedText :=
				highlightingParser
					asHighlightedTextWithRemainderColored: self errorColor
					startingAt:
						(parser currentPosition >= aString size
							ifTrue: [1]
							ifFalse: [parser currentPosition])].
	encodingName := highlightingParser encodingName.

	^ highlightedText.! !

!GLMXMLHighlighterTextStylerDecorator methodsFor: 'parsing' stamp: 'monty 10/1/2015 21:54'!
parser
	^ self! !

SAXParserDriver subclass: #SAXPositionParserDriver
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-GTExtensions-Highlighting-Parser'!

!SAXPositionParserDriver commentStamp: 'monty 10/2/2015 06:23' prior: 0!
This class is a non-validating SAX driver that forwards token start/end positions to a SAXHandler.!

!SAXPositionParserDriver methodsFor: 'testing' stamp: 'monty 9/30/2015 03:50'!
decodesCharacters
	^ false! !

!SAXPositionParserDriver methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:44'!
handleEndCDataPosition: aPosition
	self saxHandler endCDataPosition: aPosition! !

!SAXPositionParserDriver methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:30'!
handleEndCommentPosition: aPosition
	self saxHandler endCommentPosition: aPosition! !

!SAXPositionParserDriver methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:45'!
handleEndDeclaration: aPosition
	self saxHandler endDeclarationPosition: aPosition! !

!SAXPositionParserDriver methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:33'!
handleEndDoctypeDeclarationPosition: aPosition
	self saxHandler endDoctypeDeclarationPosition: aPosition! !

!SAXPositionParserDriver methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:32'!
handleEndEntityReferencePosition: aPosition
	self saxHandler endEntityReferencePosition: aPosition! !

!SAXPositionParserDriver methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:31'!
handleEndPIPosition: aPosition
	self saxHandler endPIPosition: aPosition! !

!SAXPositionParserDriver methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:31'!
handleEndQuotedStringValuePosition: aPosition
	self saxHandler endQuotedStringValuePosition: aPosition! !

!SAXPositionParserDriver methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:28'!
handleEndTagPosition: aPosition
	self saxHandler endTagPosition: aPosition! !

!SAXPositionParserDriver methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:28'!
handleEndXMLDeclarationPosition: aPosition
	self saxHandler endXMLDeclarationPosition: aPosition! !

!SAXPositionParserDriver methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:43'!
handleStartCDataPosition: aPosition
	self saxHandler startCDataPosition: aPosition! !

!SAXPositionParserDriver methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:30'!
handleStartCommentPosition: aPosition
	self saxHandler startCommentPosition: aPosition! !

!SAXPositionParserDriver methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:45'!
handleStartDeclaration: aPosition
	self saxHandler startDeclarationPosition: aPosition! !

!SAXPositionParserDriver methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:33'!
handleStartDoctypeDeclarationPosition: aPosition
	self saxHandler startDoctypeDeclarationPosition: aPosition! !

!SAXPositionParserDriver methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:32'!
handleStartEntityReferencePosition: aPosition
	self saxHandler startEntityReferencePosition: aPosition! !

!SAXPositionParserDriver methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:31'!
handleStartPIPosition: aPosition
	self saxHandler startPIPosition: aPosition! !

!SAXPositionParserDriver methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:30'!
handleStartQuotedStringValuePosition: aPosition
	self saxHandler startQuotedStringValuePosition: aPosition! !

!SAXPositionParserDriver methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:26'!
handleStartTagPosition: aPosition
	self saxHandler startTagPosition: aPosition! !

!SAXPositionParserDriver methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:25'!
handleStartXMLDeclarationPosition: aPosition
	self saxHandler startXMLDeclarationPosition: aPosition! !

!SAXPositionParserDriver methodsFor: 'testing' stamp: 'monty 9/30/2015 20:45'!
isValidating
	^ false! !

!SAXPositionParserDriver methodsFor: 'private' stamp: 'monty 10/1/2015 04:35'!
tokenizerClass
	^ XMLPositionWellFormedParserTokenizer! !

XMLWriter subclass: #XMLHighlightingWriter
	instanceVariableNames: 'highlighter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-GTExtensions-Highlighting-Writer'!

!XMLHighlightingWriter commentStamp: 'monty 10/1/2015 04:20' prior: 0!
This class is an XMLWriter that can make highlighted text output with XMLHighlightingPrettyPrintingWriterFormatter and XMLHighlighter.!

!XMLHighlightingWriter class methodsFor: 'instance creation' stamp: 'monty 9/21/2015 06:41'!
on: aStream
	^ (super on: aStream) formatter: XMLHighlightingPrettyPrintingWriterFormatter new! !

!XMLHighlightingWriter methodsFor: 'converting' stamp: 'monty 10/1/2015 03:19'!
asHighlightedText
	| text |

	text := self asString asText.
	self highlighter highlightText: text.
	^ text.! !

!XMLHighlightingWriter methodsFor: 'accessing' stamp: 'monty 10/1/2015 03:19'!
highlighter
	^ highlighter! !

!XMLHighlightingWriter methodsFor: 'initialization' stamp: 'monty 10/1/2015 03:14'!
initialize
	super initialize.

	highlighter := XMLHighlighter new.! !

!XMLHighlightingWriter methodsFor: 'accessing' stamp: 'monty 10/1/2015 03:49'!
position
	^ stream position! !

XMLWellFormedParserTokenizer subclass: #XMLPositionWellFormedParserTokenizer
	instanceVariableNames: 'initialReadLimit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-GTExtensions-Highlighting-Parser'!

!XMLPositionWellFormedParserTokenizer commentStamp: 'monty 10/2/2015 06:17' prior: 0!
This class is a tokenizer that tracks token start/end positions. Does not support entities.!

!XMLPositionWellFormedParserTokenizer methodsFor: 'accessing' stamp: 'monty 10/2/2015 04:50'!
currentPosition
	^ initialReadLimit - streamReader readLimit + 1! !

!XMLPositionWellFormedParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 10/2/2015 02:25'!
nextAttributeValue
	| attributeValue |

	driver handleStartQuotedStringValuePosition: self currentPosition + 1.
	attributeValue := super nextAttributeValue.
	driver handleEndQuotedStringValuePosition: self currentPosition - 1.
	^ attributeValue.! !

!XMLPositionWellFormedParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 10/1/2015 04:43'!
nextCDataSection
	driver handleStartCDataPosition: self currentPosition - 2.
	super nextCDataSection.
	driver handleEndCDataPosition: self currentPosition - 1.! !

!XMLPositionWellFormedParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 10/1/2015 05:10'!
nextCharacterReferenceOnWriteStream
	driver handleStartEntityReferencePosition: self currentPosition - 2.
	self nextInteger
		ifNil: [self errorExpected: 'integer'].
	driver handleEndEntityReferencePosition: self currentPosition.
	self expectNext: $;.
	^ false.! !

!XMLPositionWellFormedParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 9/30/2015 06:56'!
nextComment
	driver handleStartCommentPosition: self currentPosition - 2.
	super nextComment.
	driver handleEndCommentPosition: self currentPosition - 1.! !

!XMLPositionWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 10/1/2015 04:57'!
nextDoctypeDeclaration
	driver handleStartDoctypeDeclarationPosition: self currentPosition - 2.
	super nextDoctypeDeclaration.! !

!XMLPositionWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 9/30/2015 07:10'!
nextEndDoctypeDeclaration
	super nextEndDoctypeDeclaration.
	driver handleEndDoctypeDeclarationPosition: self currentPosition - 1.! !

!XMLPositionWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 10/2/2015 02:26'!
nextEntityValue
	| entityValue |

	driver handleStartQuotedStringValuePosition: self currentPosition + 1.
	entityValue := super nextEntityValue.
	driver handleEndQuotedStringValuePosition: self currentPosition - 1.
	^ entityValue.! !

!XMLPositionWellFormedParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 10/1/2015 05:10'!
nextGeneralEntityReferenceOnWriteStream
	driver handleStartEntityReferencePosition: self currentPosition - 1.
	self nextName.
	driver handleEndEntityReferencePosition: self currentPosition.
	self expectNext: $;.
	^ false.! !

!XMLPositionWellFormedParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 10/1/2015 05:16'!
nextPIWithTarget: aTarget
	driver handleStartPIPosition: self currentPosition - (2 + aTarget size).
	super nextPIWithTarget: aTarget.
	driver handleEndPIPosition: self currentPosition - 1.! !

!XMLPositionWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 10/1/2015 05:11'!
nextParameterEntityReference
	driver handleStartEntityReferencePosition: self currentPosition - 1.
	self nextName.
	driver handleEndEntityReferencePosition: self currentPosition.
	self expectNext: $;.
	^ false.! !

!XMLPositionWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 10/1/2015 05:11'!
nextParameterEntityReferenceInDeclaration
	^ self nextParameterEntityReference! !

!XMLPositionWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 10/1/2015 05:11'!
nextParameterEntityReferenceOnWriteStream
	^ self nextParameterEntityReference! !

!XMLPositionWellFormedParserTokenizer methodsFor: 'tokenizing - dtd' stamp: 'monty 9/30/2015 03:58'!
nextSubsetDeclaration
	driver handleStartDeclaration: self currentPosition + 2.
	super nextSubsetDeclaration.
	driver handleEndDeclaration: self currentPosition - 1.! !

!XMLPositionWellFormedParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 9/30/2015 06:52'!
nextTag
	driver handleStartTagPosition: self currentPosition - 1.
	super nextTag.
	driver handleEndTagPosition: self currentPosition - 1.! !

!XMLPositionWellFormedParserTokenizer methodsFor: 'tokenizing' stamp: 'monty 9/30/2015 07:10'!
nextXMLDeclaration
	driver handleStartXMLDeclarationPosition: self currentPosition - 5. "'<?xml' size"
	super nextXMLDeclaration.
	driver handleEndXMLDeclarationPosition: self currentPosition - 1.! !

!XMLPositionWellFormedParserTokenizer methodsFor: 'initialization' stamp: 'monty 9/30/2015 03:41'!
setDriver: aDriver stream: aStream readLimit: aReadLimit
	super
		setDriver: aDriver
		stream: aStream
		readLimit: aReadLimit.
	initialReadLimit := aReadLimit.! !

SAXHandler subclass: #SAXPositionHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-GTExtensions-Highlighting-Parser'!

!SAXPositionHandler commentStamp: 'monty 10/2/2015 04:56' prior: 0!
This class is a SAXHandler that can track the positions of tokens. Does not support validation or entity replacement but can check wellformedness and namespaces.!

!SAXPositionHandler methodsFor: 'private' stamp: 'monty 10/1/2015 04:26'!
driverClass
	^ SAXPositionParserDriver! !

!SAXPositionHandler methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:44'!
endCDataPosition: aPosition! !

!SAXPositionHandler methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:30'!
endCommentPosition: aPosition! !

!SAXPositionHandler methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:46'!
endDeclarationPosition: aPosition! !

!SAXPositionHandler methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:33'!
endDoctypeDeclarationPosition: aPosition! !

!SAXPositionHandler methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:32'!
endEntityReferencePosition: aPosition! !

!SAXPositionHandler methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:31'!
endPIPosition: aPosition! !

!SAXPositionHandler methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:30'!
endQuotedStringValuePosition: aPosition! !

!SAXPositionHandler methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:27'!
endTagPosition: aPosition! !

!SAXPositionHandler methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:27'!
endXMLDeclarationPosition: aPosition! !

!SAXPositionHandler methodsFor: 'private' stamp: 'monty 10/1/2015 04:26'!
parserClass
	^ XMLPositionParser! !

!SAXPositionHandler methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:43'!
startCDataPosition: aPosition! !

!SAXPositionHandler methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:30'!
startCommentPosition: aPosition! !

!SAXPositionHandler methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:46'!
startDeclarationPosition: aPosition! !

!SAXPositionHandler methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:33'!
startDoctypeDeclarationPosition: aPosition! !

!SAXPositionHandler methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:32'!
startEntityReferencePosition: aPosition! !

!SAXPositionHandler methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:31'!
startPIPosition: aPosition! !

!SAXPositionHandler methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:30'!
startQuotedStringValuePosition: aPosition! !

!SAXPositionHandler methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:26'!
startTagPosition: aPosition! !

!SAXPositionHandler methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 02:26'!
startXMLDeclarationPosition: aPosition! !

SAXPositionHandler subclass: #XMLHighlightingParser
	instanceVariableNames: 'highlighter encodingName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-GTExtensions-Highlighting-Parser'!

!XMLHighlightingParser commentStamp: 'monty 10/2/2015 04:56' prior: 0!
This class is an XML parser that can convert its input to styled Text objects after parsing.!

!XMLHighlightingParser methodsFor: 'converting' stamp: 'monty 10/1/2015 22:24'!
asHighlightedText
	| text |

	text := self inputText.
	highlighter highlightText: text.
	^ text.! !

!XMLHighlightingParser methodsFor: 'converting' stamp: 'monty 10/2/2015 02:11'!
asHighlightedTextWithRemainderColored: aTextColor startingAt: aPosition
	| text |

	text := self asHighlightedText.
	highlighter
		highlightText: text
		withColor: aTextColor
		startingAt: aPosition.
	^ text.! !

!XMLHighlightingParser methodsFor: 'accessing' stamp: 'monty 10/3/2015 01:54'!
encodingName
	^ encodingName! !

!XMLHighlightingParser methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:49'!
endCDataPosition: aPosition
	highlighter endCDataHighlightPosition: aPosition! !

!XMLHighlightingParser methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:49'!
endCommentPosition: aPosition
	highlighter endCommentHighlightPosition: aPosition! !

!XMLHighlightingParser methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:49'!
endDeclarationPosition: aPosition
	highlighter endDeclarationHighlightPosition: aPosition! !

!XMLHighlightingParser methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:49'!
endDoctypeDeclarationPosition: aPosition
	highlighter endDoctypeDeclarationHighlightPosition: aPosition! !

!XMLHighlightingParser methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:49'!
endEntityReferencePosition: aPosition
	highlighter endEntityReferenceHighlightPosition: aPosition! !

!XMLHighlightingParser methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:49'!
endPIPosition: aPosition
	highlighter endPIHighlightPosition: aPosition! !

!XMLHighlightingParser methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:49'!
endQuotedStringValuePosition: aPosition
	highlighter endQuotedStringValueHighlightPosition: aPosition! !

!XMLHighlightingParser methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:49'!
endTagPosition: aPosition
	highlighter endTagHighlightPosition: aPosition! !

!XMLHighlightingParser methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:49'!
endXMLDeclarationPosition: aPosition
	highlighter endXMLDeclarationHighlightPosition: aPosition! !

!XMLHighlightingParser methodsFor: 'accessing' stamp: 'monty 10/1/2015 04:50'!
highlighter
	^ highlighter! !

!XMLHighlightingParser methodsFor: 'private' stamp: 'monty 10/1/2015 22:24'!
inputText
	^ self input asString asText! !

!XMLHighlightingParser methodsFor: 'initialization' stamp: 'monty 10/3/2015 02:06'!
on: aStringOrStream
	super on: aStringOrStream.

	highlighter := XMLHighlighter new.
	encodingName := ''.! !

!XMLHighlightingParser methodsFor: 'parsing' stamp: 'monty 10/1/2015 22:22'!
parsingResult
	^ self asHighlightedText! !

!XMLHighlightingParser methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:43'!
startCDataPosition: aPosition
	highlighter startCDataHighlightPosition: aPosition! !

!XMLHighlightingParser methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:47'!
startCommentPosition: aPosition
	highlighter startCommentHighlightPosition: aPosition! !

!XMLHighlightingParser methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:44'!
startDeclarationPosition: aPosition
	highlighter startDeclarationHighlightPosition: aPosition! !

!XMLHighlightingParser methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:46'!
startDoctypeDeclarationPosition: aPosition
	highlighter startDoctypeDeclarationHighlightPosition: aPosition! !

!XMLHighlightingParser methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:48'!
startEntityReferencePosition: aPosition
	highlighter startEntityReferenceHighlightPosition: aPosition! !

!XMLHighlightingParser methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:47'!
startPIPosition: aPosition
	highlighter startPIHighlightPosition: aPosition! !

!XMLHighlightingParser methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:47'!
startQuotedStringValuePosition: aPosition
	highlighter startQuotedStringValueHighlightPosition: aPosition! !

!XMLHighlightingParser methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:48'!
startTagPosition: aPosition
	highlighter startTagHighlightPosition: aPosition! !

!XMLHighlightingParser methodsFor: 'handling - positions' stamp: 'monty 10/1/2015 04:46'!
startXMLDeclarationPosition: aPosition
	highlighter startXMLDeclarationHighlightPosition: aPosition! !

!XMLHighlightingParser methodsFor: 'handling - content' stamp: 'monty 10/3/2015 01:54'!
xmlVersion: aVersionFloat encoding: anEncoding standalone: aBoolean
	encodingName := anEncoding! !

!XMLElement class methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 9/20/2015 22:19'!
gtExampleXmlNode
	<gtExample>
	^ XMLDocument gtExampleXmlNode firstElement! !

!XMLElement methodsFor: '*XML-Parser-GTExtensions' stamp: 'AndreiChis 7/12/2014 16:48'!
formForImageEntity: imageEntity
  | imageType parserClassName parserClass parser |
  imageType := imageEntity contentType sub.
  parserClassName := imageType asUppercase, #ReadWriter.
  parserClass := Smalltalk globals at: parserClassName asSymbol.
  parser := parserClass on: imageEntity readStream.
    ^ parser nextImage! !

!XMLElement methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 10/2/2015 06:09'!
gtInspectorImageIn: composite inContext: aGTInspector
	<gtInspectorPresentationOrder: 40>
	| client url |
	aGTInspector panes size > 1
		ifFalse: [ ^ self ].
	client := (aGTInspector panes reversed collect: [ :each | (each port: #entity) value ])
		detect: [ :each | (each isKindOf: ZnClient) and: [ each request notNil ] ]
		ifNone: [ ^ self ].
	url := client request absoluteUrl.
	^ composite morph
		title: 'Image';
		display:
				[ self
				formForImageEntity:
					(ZnClient new
						beOneShot;
						get: url / (self attributeAt: 'src');
						entity) ];
		when: [ (self isNamed: 'img') and: [ self includesAttribute: 'src' ] ]! !

!XMLElement methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 9/23/2015 19:13'!
hasTreeNodeChildren
	^ self hasChildren
		and: [self nodes size > 1
			or: [self nodes first isStringNode not]]! !

!XMLElement methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 9/23/2015 18:48'!
treeNodeChildren
	self hasTreeNodeChildren
		ifTrue: [^ self nodes]
		ifFalse: [^ #()]! !

!XMLElement methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 9/29/2015 19:09'!
writeTreeNodeLabelXMLOn: aWriter
	self hasTreeNodeChildren
		ifTrue: [
			aWriter startTag
				name: self name;
				setAttributes: attributes]
		ifFalse: [| tagWriter |
			(tagWriter := aWriter tag)
				name: self name;
				setAttributes: attributes.
			self hasChildren
				ifTrue: [tagWriter with: [self writeInnerXMLOn: aWriter]]].! !

!XMLDocument class methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 9/20/2015 22:19'!
gtExampleXmlNode
	<gtExample>
	^ XMLDOMParser parse: '<document><a></a><b></b></document>'! !

!XMLDocument methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 9/23/2015 19:48'!
hasTreeNodeChildren
	^ self hasChildren
		or: [self hasDoctypeDeclaration]! !

!XMLDocument methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 9/23/2015 19:56'!
treeNodeChildren
	self hasDoctypeDeclaration
		ifTrue: [^ self nodes copyWithFirst: self doctypeDeclaration]
		ifFalse: [^ self nodes]! !

!XMLDocument methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 9/29/2015 19:09'!
writeTreeNodeLabelXMLOn: aWriter
	self writeXMLDeclarationOn: aWriter! !

!XMLNodeWithElements class methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 9/20/2015 22:19'!
gtExampleXmlNode
	<gtExample>
	^ XMLDocument gtExampleXmlNode nodes! !

!XMLNodeWithElements methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 10/1/2015 06:03'!
spotterForAllElementsFor: aStep
	<spotterOrder: 40>
	aStep listProcessor
		title: 'All elements';
		allCandidates: [self allElements];
		itemName: #gtDisplayString;
		filter: GTFilterSubstring;
		wantsToDisplayOnEmptyQuery: true! !

!XMLNodeWithElements methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 10/1/2015 06:03'!
spotterForDirectElementsFor: aStep
	<spotterOrder: 40>
	aStep listProcessor
		title: 'Direct elements';
		allCandidates: [self elements];
		itemName: #gtDisplayString;
		filter: GTFilterSubstring;
		wantsToDisplayOnEmptyQuery: true! !

!XMLNodeWithElements methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 9/29/2015 23:16'!
spotterPreviewSourceIn: aComposite
	<spotterPreview: 10>
	
	aComposite text
		title: 'Source';
		display: [
			self asHighlightedTextWrittenWith: [:writer |
				"use less indent for spotter previews"
				writer formatter indentString: '  '.
				self writeXMLOn: writer]];
		entity: self! !

!FileReference methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 10/4/2015 03:01'!
gtInspectorXMLFileIn: aComposite
	<gtInspectorPresentationOrder: 4>

	| currentTextStylerDecorator |

	self isXMLFile
		ifFalse: [^ self].

	aComposite custom:
		(GLMRubricHighlightedTextPresentation new
			title: 'Source';
			editingMode: [
				"saved to get the converter later"
				currentTextStylerDecorator := GLMXMLHighlighterTextStylerDecorator new.
				GLMHighlighterTextRubEditingMode withStylerDecorator: currentTextStylerDecorator];
			display: [XMLPositionExternalStreamConverter convert: self readStream];
			withLineNumbers: true;
			act: [:presentation | | outputConverter outputString |
					"can raise exceptions so must be called before deleting"
					outputConverter := currentTextStylerDecorator converter.
					outputString := presentation text asString.
					self
						ensureDelete;
						writeStreamDo: [:stream |
							outputConverter
								ifNotNil: [stream converter: outputConverter].
							stream nextPutAll: outputString]]
				icon: GLMUIThemeExtraIcons glamorousSave
				on: $s
				entitled: 'Save')! !

!FileReference methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 10/1/2015 06:02'!
isXMLFile
	^ #('xml' 'xhtml') includes: self extension asLowercase! !

!FileReference methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 10/2/2015 04:47'!
spotterForXMLFileFor: aStep
	<spotterOrder: 40>

	self isXMLFile
		ifFalse: [^ self].

	aStep listProcessor
		title: 'XML Document';
		allCandidates: [(XMLDOMParser parse: self readStream) allElements];
		itemName: #gtDisplayString;
		filter: GTFilterSubstring;
		wantsToDisplayOnEmptyQuery: true! !

!FileReference methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 10/1/2015 20:41'!
spotterPreviewXMLFileIn: aComposite
	<spotterPreview: 10>

	self isXMLFile
		ifFalse: [^ self].

	aComposite text
		title: 'Source';
		display: [
			XMLHighlightingParser parse:
				(XMLPositionExternalStreamConverter convert: self readStream)];
		entity: self.! !

XMLParser subclass: #XMLPositionParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-GTExtensions-Highlighting-Parser'!

!XMLPositionParser commentStamp: 'monty 10/2/2015 06:16' prior: 0!
This class allows access to the current 1-based  input position.!

!XMLPositionParser methodsFor: 'accessing' stamp: 'monty 10/1/2015 02:22'!
currentPosition
	^ self tokenizer currentPosition! !

XMLPrettyPrintingWriterFormatter subclass: #XMLHighlightingPrettyPrintingWriterFormatter
	instanceVariableNames: 'highlighter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-GTExtensions-Highlighting-Writer'!

!XMLHighlightingPrettyPrintingWriterFormatter commentStamp: 'monty 9/21/2015 06:43' prior: 0!
This formatter adds highlights to XMLHighlightingWriter output.!

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'private' stamp: 'monty 10/1/2015 04:01'!
endPosition
	^ self writer position! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 10/1/2015 03:50'!
formatAfterCData: aCDataWriter
	highlighter endCDataHighlightPosition: self endPosition.

	super formatAfterCData: aCDataWriter.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 10/1/2015 03:50'!
formatAfterCharacterEscape: aCharacterEscape
	highlighter endEntityReferenceHighlightPosition: self endPosition.

	super formatAfterCharacterEscape: aCharacterEscape.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 10/1/2015 03:50'!
formatAfterComment: aCommentWriter
	highlighter endCommentHighlightPosition: self endPosition.

	super formatAfterComment: aCommentWriter.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 10/1/2015 03:50'!
formatAfterDeclaration: aDeclarationWriter
	highlighter endDeclarationHighlightPosition: self endPosition.

	super formatAfterDeclaration: aDeclarationWriter.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 10/1/2015 03:50'!
formatAfterDoctypeDeclaration: aDoctypeDeclarationWriter
	highlighter endDoctypeDeclarationHighlightPosition: self endPosition.

	super formatAfterDoctypeDeclaration: aDoctypeDeclarationWriter.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 10/1/2015 03:51'!
formatAfterEndTag: aTagWriter
	highlighter endTagHighlightPosition: self endPosition.

	super formatAfterEndTag: aTagWriter.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 10/1/2015 03:51'!
formatAfterEntityReference: anEntityReferenceWriter
	highlighter endEntityReferenceHighlightPosition: self endPosition.

	super formatAfterEntityReference: anEntityReferenceWriter.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 10/1/2015 04:13'!
formatAfterPI: aPIWriter
	highlighter endPIHighlightPosition: self endPosition.

	super formatAfterPI: aPIWriter.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 10/1/2015 03:51'!
formatAfterQuotedStringValue: aString
	highlighter endQuotedStringValueHighlightPosition: self endPosition.

	super formatAfterQuotedStringValue: aString.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 10/1/2015 03:51'!
formatAfterStartTag: aTagWriter
	highlighter endTagHighlightPosition: self endPosition.

	super formatAfterStartTag: aTagWriter.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 10/1/2015 03:51'!
formatAfterXMLDeclaration: anXMLDeclarationWriter
	highlighter endXMLDeclarationHighlightPosition: self endPosition.

	super formatAfterXMLDeclaration: anXMLDeclarationWriter.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 10/1/2015 03:50'!
formatBeforeCData: aCDataWriter
	super formatBeforeCData: aCDataWriter.

	highlighter startCDataHighlightPosition: self startPosition.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 10/1/2015 03:50'!
formatBeforeCharacterEscape: aCharacterEscape
	super formatBeforeCharacterEscape: aCharacterEscape.

	highlighter startEntityReferenceHighlightPosition: self startPosition.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 10/1/2015 03:50'!
formatBeforeComment: aCommentWriter
	super formatBeforeComment: aCommentWriter.

	highlighter startCommentHighlightPosition: self startPosition.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 10/1/2015 03:50'!
formatBeforeDeclaration: aDeclarationWriter
	super formatBeforeDeclaration: aDeclarationWriter.

	highlighter startDeclarationHighlightPosition: self startPosition.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 10/1/2015 03:50'!
formatBeforeDoctypeDeclaration: aDoctypeDeclarationWriter
	super formatBeforeDoctypeDeclaration: aDoctypeDeclarationWriter.

	highlighter startDoctypeDeclarationHighlightPosition: self startPosition.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 10/1/2015 03:50'!
formatBeforeEndTag: aTagWriter
	super formatBeforeEndTag: aTagWriter.

	highlighter startTagHighlightPosition: self startPosition.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 10/1/2015 03:50'!
formatBeforeEntityReference: anEntityReferenceWriter
	super formatBeforeEntityReference: anEntityReferenceWriter.

	highlighter startEntityReferenceHighlightPosition: self startPosition.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 10/1/2015 03:50'!
formatBeforePI: aPIWriter
	super formatBeforePI: aPIWriter.

	highlighter startPIHighlightPosition: self startPosition.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 10/1/2015 03:50'!
formatBeforeQuotedStringValue: aString
	super formatBeforeQuotedStringValue: aString.

	highlighter startQuotedStringValueHighlightPosition: self startPosition.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 10/1/2015 03:50'!
formatBeforeStartTag: aTagWriter
	super formatBeforeStartTag: aTagWriter.

	highlighter startTagHighlightPosition: self startPosition.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'formatting' stamp: 'monty 10/1/2015 03:50'!
formatBeforeXMLDeclaration: anXMLDeclarationWriter
	super formatBeforeXMLDeclaration: anXMLDeclarationWriter.

	highlighter startXMLDeclarationHighlightPosition: self startPosition.! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'private' stamp: 'monty 10/1/2015 04:00'!
startPosition
	^ self writer position + 1! !

!XMLHighlightingPrettyPrintingWriterFormatter methodsFor: 'accessing' stamp: 'monty 10/1/2015 03:19'!
writer: aWriter
	super writer: aWriter.

	highlighter := aWriter highlighter.! !

!XMLNode class methodsFor: '*XML-Parser-GTExtensions' stamp: 'AndreiChis 10/6/2015 10:47'!
gtExampleNodeWithParent
	<gtExample>
	^ self new parent: self new! !

!XMLNode methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 9/29/2015 22:42'!
asHighlightedText
	^ self asHighlightedTextWrittenWith: [:writer | self writeXMLOn: writer]! !

!XMLNode methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 9/29/2015 22:42'!
asHighlightedTextWrittenWith: aBlock
	| writer |

	writer := XMLHighlightingWriter new.
	self escapesContentEntitiesWhenWriting
		ifFalse: [writer escapesContentEntityReferences: false].
	aBlock value: writer.
	^ writer asHighlightedText.! !

!XMLNode methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 9/23/2015 21:02'!
gtInspectorSourceIn: composite
	<gtInspectorPresentationOrder: 40>

	"removed unfinished source panel editing support for now"
	composite text 
		title: 'Source';
		format: #asHighlightedText! !

!XMLNode methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 9/23/2015 21:02'!
gtInspectorTreeIn: composite
	<gtInspectorPresentationOrder: 40>
	^ composite tree
		title: 'Tree';
		display: [ {self} ];
		children: #treeNodeChildren;
		format: #treeNodeLabelText;
		when: [self hasTreeNodeChildren];
		rootsExpanded! !

!XMLNode methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 9/23/2015 18:19'!
hasTreeNodeChildren
	^ self hasChildren! !

!XMLNode methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 9/23/2015 17:12'!
treeNodeChildren
	^ #()! !

!XMLNode methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 9/29/2015 22:42'!
treeNodeLabelText
	^ self asHighlightedTextWrittenWith: [:writer | self writeTreeNodeLabelXMLOn: writer]! !

!XMLNode methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 9/29/2015 19:09'!
writeTreeNodeLabelXMLOn: aWriter
	self writeXMLOn: aWriter! !

Object subclass: #XMLHighlight
	instanceVariableNames: 'color start end'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-GTExtensions-Highlighting'!

!XMLHighlight commentStamp: 'monty 9/21/2015 04:24' prior: 0!
This class stores a highlight TextColor and 1-based start/end highlight positions.!

!XMLHighlight methodsFor: 'highlighting' stamp: 'monty 9/28/2015 05:24'!
applyToText: aText
	| attributeStart attributeEnd |

	attributeStart := self start ifNil: [1].
	attributeEnd := self end ifNil: [aText size].
	attributeStart < attributeEnd
		ifTrue: [
			aText
				addAttribute: self color
				from: attributeStart
				to: attributeEnd].! !

!XMLHighlight methodsFor: 'accessing' stamp: 'monty 9/20/2015 01:08'!
color
	^ color! !

!XMLHighlight methodsFor: 'accessing' stamp: 'monty 9/20/2015 01:10'!
color: aTextColor
	color := aTextColor! !

!XMLHighlight methodsFor: 'accessing' stamp: 'monty 9/20/2015 01:08'!
end
	^ end! !

!XMLHighlight methodsFor: 'accessing' stamp: 'monty 9/20/2015 01:10'!
end: anEndPosition
	end := anEndPosition! !

!XMLHighlight methodsFor: 'accessing' stamp: 'monty 9/20/2015 01:08'!
start
	^ start! !

!XMLHighlight methodsFor: 'accessing' stamp: 'monty 9/20/2015 01:10'!
start: aStartPosition
	start := aStartPosition! !

Object subclass: #XMLHighlightDefaults
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-GTExtensions-Highlighting'!

XMLHighlightDefaults class
	instanceVariableNames: 'defaultDefaultColor defaultCDataColor defaultCommentColor defaultEntityReferenceColor defaultPrimaryMarkupColor defaultQuotedStringValueColor defaultSecondaryMarkupColor'!

!XMLHighlightDefaults commentStamp: 'monty 10/1/2015 04:18' prior: 0!
This class stores the default highlight TextColors used by the highlighter. It gets the initial defaults from Shout text styling.!

XMLHighlightDefaults class
	instanceVariableNames: 'defaultDefaultColor defaultCDataColor defaultCommentColor defaultEntityReferenceColor defaultPrimaryMarkupColor defaultQuotedStringValueColor defaultSecondaryMarkupColor'!

!XMLHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 9/30/2015 20:31'!
defaultCDataColor
	^ defaultCDataColor
		ifNil: [defaultCDataColor := self textColorForShoutProperty: #primitive]! !

!XMLHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 9/30/2015 20:31'!
defaultCDataColor: aTextColor
	defaultCDataColor := aTextColor! !

!XMLHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 9/30/2015 20:31'!
defaultCommentColor
	^ defaultCommentColor
		ifNil: [defaultCommentColor :=  self textColorForShoutProperty: #comment]! !

!XMLHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 9/30/2015 20:31'!
defaultCommentColor: aTextColor
	defaultCommentColor := aTextColor! !

!XMLHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 9/30/2015 20:31'!
defaultDefaultColor
	^ defaultDefaultColor
		ifNil: [defaultDefaultColor := self textColorForShoutProperty: #default]! !

!XMLHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 9/30/2015 20:31'!
defaultDefaultColor: aTextColor
	defaultDefaultColor := aTextColor! !

!XMLHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 9/30/2015 20:31'!
defaultEntityReferenceColor
	^ defaultEntityReferenceColor
		ifNil: [defaultEntityReferenceColor := self textColorForShoutProperty: #character]! !

!XMLHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 9/30/2015 20:31'!
defaultEntityReferenceColor: aTextColor
	defaultEntityReferenceColor := aTextColor! !

!XMLHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 9/30/2015 20:31'!
defaultPrimaryMarkupColor
	^ defaultPrimaryMarkupColor
		ifNil: [defaultPrimaryMarkupColor := self textColorForShoutProperty: #argument]! !

!XMLHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 9/30/2015 20:31'!
defaultPrimaryMarkupColor: aTextColor
	defaultPrimaryMarkupColor := aTextColor! !

!XMLHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 9/30/2015 20:31'!
defaultQuotedStringValueColor
	^ defaultQuotedStringValueColor
		ifNil: [defaultQuotedStringValueColor := self textColorForShoutProperty: #string]! !

!XMLHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 9/30/2015 20:31'!
defaultQuotedStringValueColor: aTextColor
	defaultQuotedStringValueColor := aTextColor! !

!XMLHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 9/30/2015 20:31'!
defaultSecondaryMarkupColor
	^ defaultSecondaryMarkupColor
		ifNil: [defaultSecondaryMarkupColor := self textColorForShoutProperty: #self]! !

!XMLHighlightDefaults class methodsFor: 'accessing' stamp: 'monty 9/30/2015 20:31'!
defaultSecondaryMarkupColor: aTextColor
	defaultSecondaryMarkupColor := aTextColor! !

!XMLHighlightDefaults class methodsFor: 'class initialization' stamp: 'monty 9/30/2015 20:32'!
initialize
	"self initialize"

	self
		defaultDefaultColor: nil;
		defaultPrimaryMarkupColor: nil;
		defaultSecondaryMarkupColor: nil;
		defaultQuotedStringValueColor: nil;
		defaultEntityReferenceColor: nil;
		defaultCommentColor: nil;
		defaultCDataColor: nil! !

XMLHighlightDefaults initialize!

!XMLHighlightDefaults class methodsFor: 'private' stamp: 'monty 9/30/2015 20:32'!
textColorForShoutProperty: aShoutProperty
	^ TextColor color:
		(((SHTextStylerST80 new attributesFor: aShoutProperty)
			detect: [:each | each respondsTo: #color]
			ifNone: [^ nil]) color)! !

Object subclass: #XMLHighlighter
	instanceVariableNames: 'xmlDeclarationColor doctypeDeclarationColor declarationColor piColor entityReferenceColor commentColor tagColor cdataColor quotedStringValueColor highlights defaultHighlight xmlDeclarationHighlight doctypeDeclarationHighlight declarationHighlight piHighlight entityReferenceHighlight commentHighlight tagHighlight cdataHighlight quotedStringValueHighlight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-GTExtensions-Highlighting'!

!XMLHighlighter commentStamp: 'monty 10/1/2015 03:57' prior: 0!
This class is used to highlight Text objects containing XML source.!

!XMLHighlighter methodsFor: 'accessing' stamp: 'monty 10/1/2015 03:16'!
cdataColor
	^ cdataColor! !

!XMLHighlighter methodsFor: 'accessing' stamp: 'monty 10/1/2015 03:16'!
cdataColor: aTextColor
	cdataColor := aTextColor! !

!XMLHighlighter methodsFor: 'accessing' stamp: 'monty 10/1/2015 03:16'!
commentColor
	^ commentColor! !

!XMLHighlighter methodsFor: 'accessing' stamp: 'monty 10/1/2015 03:16'!
commentColor: aTextColor
	commentColor := aTextColor! !

!XMLHighlighter methodsFor: 'accessing' stamp: 'monty 10/1/2015 03:16'!
declarationColor
	^ declarationColor! !

!XMLHighlighter methodsFor: 'accessing' stamp: 'monty 10/1/2015 03:16'!
declarationColor: aTextColor
	declarationColor := aTextColor! !

!XMLHighlighter methodsFor: 'accessing' stamp: 'monty 10/1/2015 03:16'!
defaultColor
	^ defaultHighlight color! !

!XMLHighlighter methodsFor: 'accessing' stamp: 'monty 10/1/2015 03:16'!
defaultColor: aTextColor
	defaultHighlight color: aTextColor! !

!XMLHighlighter methodsFor: 'accessing' stamp: 'monty 10/1/2015 04:04'!
defaults
	^ XMLHighlightDefaults! !

!XMLHighlighter methodsFor: 'accessing' stamp: 'monty 10/1/2015 03:16'!
doctypeDeclarationColor
	^ doctypeDeclarationColor! !

!XMLHighlighter methodsFor: 'accessing' stamp: 'monty 10/1/2015 03:16'!
doctypeDeclarationColor: aTextColor
	doctypeDeclarationColor := aTextColor! !

!XMLHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 10/1/2015 03:30'!
endCDataHighlightPosition: aPosition
	self
		endHighlight: cdataHighlight
		position: aPosition! !

!XMLHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 10/1/2015 03:30'!
endCommentHighlightPosition: aPosition
	self
		endHighlight: commentHighlight
		position: aPosition! !

!XMLHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 10/1/2015 03:31'!
endDeclarationHighlightPosition: aPosition
	self
		endHighlight: declarationHighlight
		position: aPosition! !

!XMLHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 10/1/2015 03:32'!
endDoctypeDeclarationHighlightPosition: aPosition
	self
		endHighlight: doctypeDeclarationHighlight
		position: aPosition! !

!XMLHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 10/1/2015 03:33'!
endEntityReferenceHighlightPosition: aPosition
	self
		endHighlight: entityReferenceHighlight
		position: aPosition! !

!XMLHighlighter methodsFor: 'private' stamp: 'monty 10/1/2015 03:29'!
endHighlight: aHighlightOrNil position: aPosition
	aHighlightOrNil
		ifNotNil: [aHighlightOrNil end: aPosition]! !

!XMLHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 10/1/2015 03:32'!
endPIHighlightPosition: aPosition
	self
		endHighlight: piHighlight
		position: aPosition! !

!XMLHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 10/1/2015 03:31'!
endQuotedStringValueHighlightPosition: aPosition
	self
		endHighlight: quotedStringValueHighlight
		position: aPosition! !

!XMLHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 10/1/2015 03:30'!
endTagHighlightPosition: aPosition
	self
		endHighlight: tagHighlight
		position: aPosition! !

!XMLHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 10/1/2015 03:31'!
endXMLDeclarationHighlightPosition: aPosition
	self
		endHighlight: xmlDeclarationHighlight
		position: aPosition! !

!XMLHighlighter methodsFor: 'accessing' stamp: 'monty 10/1/2015 03:16'!
entityReferenceColor
	^ entityReferenceColor! !

!XMLHighlighter methodsFor: 'accessing' stamp: 'monty 10/1/2015 03:16'!
entityReferenceColor: aTextColor
	entityReferenceColor := aTextColor! !

!XMLHighlighter methodsFor: 'highlighting' stamp: 'monty 10/1/2015 04:06'!
highlightText: aText
	highlights do: [:each | each applyToText: aText]! !

!XMLHighlighter methodsFor: 'highlighting' stamp: 'monty 10/2/2015 02:11'!
highlightText: aText withColor: aTextColor startingAt: aPosition
	XMLHighlight new
		color: aTextColor;
		start: aPosition;
		applyToText: aText! !

!XMLHighlighter methodsFor: 'initialization' stamp: 'monty 10/1/2015 03:17'!
initialize
	super initialize.

	self
		initializeHighlights;
		initializeColors.! !

!XMLHighlighter methodsFor: 'initialization' stamp: 'monty 10/1/2015 04:04'!
initializeColors
	self
		defaultColor: self defaults defaultDefaultColor;
		xmlDeclarationColor: self defaults defaultSecondaryMarkupColor;
		doctypeDeclarationColor: self defaults defaultSecondaryMarkupColor;
		piColor: self defaults defaultSecondaryMarkupColor;
		declarationColor: self defaults defaultPrimaryMarkupColor;
		tagColor: self defaults defaultPrimaryMarkupColor;
		quotedStringValueColor: self defaults defaultQuotedStringValueColor;
		entityReferenceColor: self defaults defaultEntityReferenceColor;
		commentColor: self defaults defaultCommentColor;
		cdataColor: self defaults defaultCDataColor! !

!XMLHighlighter methodsFor: 'initialization' stamp: 'monty 10/1/2015 04:11'!
initializeHighlights
	defaultHighlight := XMLHighlight new.
	highlights := OrderedCollection with: defaultHighlight.! !

!XMLHighlighter methodsFor: 'private' stamp: 'monty 10/1/2015 03:41'!
newHighlightColor: aTextColor position: aPosition
	^ aTextColor
		ifNotNil: [
			highlights addLast:
				(XMLHighlight new
					color: aTextColor;
					start: aPosition)]! !

!XMLHighlighter methodsFor: 'accessing' stamp: 'monty 10/1/2015 03:16'!
piColor
	^ piColor! !

!XMLHighlighter methodsFor: 'accessing' stamp: 'monty 10/1/2015 03:16'!
piColor: aTextColor
	piColor := aTextColor! !

!XMLHighlighter methodsFor: 'accessing' stamp: 'monty 10/1/2015 03:16'!
quotedStringValueColor
	^ quotedStringValueColor! !

!XMLHighlighter methodsFor: 'accessing' stamp: 'monty 10/1/2015 03:16'!
quotedStringValueColor: aTextColor
	quotedStringValueColor := aTextColor! !

!XMLHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 10/1/2015 03:44'!
startCDataHighlightPosition: aPosition
	cdataHighlight :=
		self
			newHighlightColor: self cdataColor
			position: aPosition! !

!XMLHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 10/1/2015 03:40'!
startCommentHighlightPosition: aPosition
	commentHighlight :=
		self
			newHighlightColor: self commentColor
			position: aPosition! !

!XMLHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 10/1/2015 03:43'!
startDeclarationHighlightPosition: aPosition
	declarationHighlight :=
		self
			newHighlightColor: self declarationColor
			position: aPosition! !

!XMLHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 10/1/2015 03:43'!
startDoctypeDeclarationHighlightPosition: aPosition
	doctypeDeclarationHighlight :=
		self
			newHighlightColor: self doctypeDeclarationColor
			position: aPosition! !

!XMLHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 10/1/2015 03:44'!
startEntityReferenceHighlightPosition: aPosition
	entityReferenceHighlight :=
		self
			newHighlightColor: self entityReferenceColor
			position: aPosition! !

!XMLHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 10/1/2015 03:40'!
startPIHighlightPosition: aPosition
	piHighlight :=
		self
			newHighlightColor: self piColor
			position: aPosition! !

!XMLHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 10/1/2015 03:44'!
startQuotedStringValueHighlightPosition: aPosition
	quotedStringValueHighlight :=
		self
			newHighlightColor: self quotedStringValueColor
			position: aPosition! !

!XMLHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 10/1/2015 03:42'!
startTagHighlightPosition: aPosition
	tagHighlight :=
		self
			newHighlightColor: self tagColor
			position: aPosition! !

!XMLHighlighter methodsFor: 'highlighting - positions' stamp: 'monty 10/1/2015 03:39'!
startXMLDeclarationHighlightPosition: aPosition
	xmlDeclarationHighlight :=
		self
			newHighlightColor: self xmlDeclarationColor
			position: aPosition! !

!XMLHighlighter methodsFor: 'accessing' stamp: 'monty 10/1/2015 03:16'!
tagColor
	^ tagColor! !

!XMLHighlighter methodsFor: 'accessing' stamp: 'monty 10/1/2015 03:16'!
tagColor: aTextColor
	tagColor := aTextColor! !

!XMLHighlighter methodsFor: 'accessing' stamp: 'monty 10/1/2015 03:16'!
xmlDeclarationColor
	^ xmlDeclarationColor! !

!XMLHighlighter methodsFor: 'accessing' stamp: 'monty 10/1/2015 03:16'!
xmlDeclarationColor: aTextColor
	xmlDeclarationColor := aTextColor! !

Object subclass: #XMLPositionExternalStreamConverter
	instanceVariableNames: 'streamReader outputStream writeStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parser-GTExtensions-Highlighting-Parser'!

!XMLPositionExternalStreamConverter commentStamp: 'monty 10/2/2015 06:13' prior: 0!
This class converts an external stream into a string with line endings normalized to CRs (the Pharo/Squeak LE) and decodes it from any of the supported character encodings.!

!XMLPositionExternalStreamConverter class methodsFor: 'converting' stamp: 'monty 10/2/2015 00:11'!
convert: aStringOrStream
	^ (self on: aStringOrStream) convert! !

!XMLPositionExternalStreamConverter class methodsFor: 'converting' stamp: 'monty 10/2/2015 00:11'!
on: aStringOrStream
	^ self
		on: aStringOrStream
		readLimit: XMLParserLimits defaultReadLimit! !

!XMLPositionExternalStreamConverter class methodsFor: 'instance creation' stamp: 'monty 10/1/2015 05:57'!
on: aStringOrStream readLimit: aReadLimit
	^ self new
		setStream:
			(aStringOrStream isStream
				ifTrue: [aStringOrStream]
				ifFalse: [aStringOrStream readStream])
		readLimit: aReadLimit! !

!XMLPositionExternalStreamConverter methodsFor: 'closing' stamp: 'monty 10/2/2015 22:17'!
close
	streamReader closeStreams! !

!XMLPositionExternalStreamConverter methodsFor: 'accessing' stamp: 'monty 10/2/2015 22:18'!
contents
	^ outputStream contents! !

!XMLPositionExternalStreamConverter methodsFor: 'converting' stamp: 'monty 10/2/2015 22:17'!
convert
	^ self
		detectCurrentEncoding;
		nextXMLDeclaration;
		skipToEnd;
		close;
		contents! !

!XMLPositionExternalStreamConverter methodsFor: 'private ' stamp: 'monty 9/30/2015 19:28'!
detectCurrentEncoding
	streamReader detectCurrentEncoding
! !

!XMLPositionExternalStreamConverter methodsFor: 'private ' stamp: 'monty 10/2/2015 04:51'!
expectNextAll: aString
	aString do: [:each |
		self next == each
			ifFalse: [^ nil]].
	^ aString.! !

!XMLPositionExternalStreamConverter methodsFor: 'private ' stamp: 'monty 9/30/2015 18:50'!
next
	^ streamReader next
		ifNotNil: [:nextChar | outputStream nextPut: nextChar]! !

!XMLPositionExternalStreamConverter methodsFor: 'private ' stamp: 'monty 10/2/2015 00:05'!
nextXMLAttributeNamed: anAttributeName
	| quote nextChar |

	self skipSeparators.
	(self expectNextAll: anAttributeName)
		ifNil: [^ nil].

	self skipSeparators.
	self next == $=
		ifFalse: [^ nil].
	self skipSeparators.

	((quote := self next) == $"
		or: [quote == $'])
		ifFalse: [^ nil].

	writeStream reset.
	[(nextChar := self next) isNil
		or: [nextChar == quote]]
		whileFalse: [writeStream nextPut: nextChar].

	nextChar
		ifNil: [^ nil]
		ifNotNil: [^ writeStream contents].! !

!XMLPositionExternalStreamConverter methodsFor: 'private ' stamp: 'monty 10/2/2015 06:10'!
nextXMLDeclaration
	self skipSeparators.
	(self expectNextAll: '<?xml')
		ifNil: [^ self].

	self skipSeparators.
	(self nextXMLAttributeNamed: 'version')
		ifNil: [^ self].

	self skipSeparators.
	(self nextXMLAttributeNamed: 'encoding')
		ifNotNil: [:encodingName | streamReader convertFromEncoding: encodingName].! !

!XMLPositionExternalStreamConverter methodsFor: 'private ' stamp: 'monty 9/30/2015 19:21'!
peek
	^ streamReader peek! !

!XMLPositionExternalStreamConverter methodsFor: 'initialization' stamp: 'monty 10/2/2015 22:19'!
setStream: aStream readLimit: aReadLimit
	streamReader :=
		XMLNestedStreamReader
			on: (XMLDecodingReadStreamAdapter onExternalStream: aStream)
			readLimit: aReadLimit.
	"this is the preferred LE char for Pharo/Squeak"
	streamReader normalizedLineEndingChar: Character cr.

	outputStream := (String new: 10240) writeStream.
	writeStream := (String new: 64) writeStream.! !

!XMLPositionExternalStreamConverter methodsFor: 'private ' stamp: 'monty 9/30/2015 19:43'!
skipSeparators
	[self peek xmlParserIsSeparator]
		whileTrue: [self next]! !

!XMLPositionExternalStreamConverter methodsFor: 'private ' stamp: 'monty 10/2/2015 22:17'!
skipToEnd
	[self next notNil] whileTrue! !

!XMLNodeWithChildren methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 9/23/2015 17:12'!
treeNodeChildren
	^ self nodes! !

XMLHighlightDefaults initialize!
